#property indicator_chart_window
#property indicator_buffers 1
extern int MinPoints = 10;
extern int BarsToCheck = 10000;
extern bool debug=false;
int spread, MaxCount, MinCount, Orders, flag1, stepopt1, BuyS[], SellS[], Population[][2], Total, opt, MaxProfit, beststep, bestflag;
double Profit;
string prefix="Loknar_";

int init() {
   spread=MarketInfo(Symbol(),MODE_SPREAD);
   if (Period()>5) spread=0;
   if (BarsToCheck>Bars) BarsToCheck=Bars;
   MaxCount=BarsToCheck/MinPoints;
   MinCount=BarsToCheck-spread;
   Total=(BarsToCheck-MinPoints)*2;
   ArrayResize(Population, Total);
   Combination();
   if (debug) Print("Max count : ",MaxCount);
   stepopt1=MinPoints;
   ArrayResize(BuyS, MaxCount);
   ArrayResize(SellS, MaxCount);
}

void deinit() {
  Comment("");
  clear();
}

void Combination() {
   for (int cc1=0;cc1<BarsToCheck-MinPoints;cc1++) {
      for (int cc2=0;cc2<2;cc2++) {
         Population[cc1*2+cc2][0]=cc1+MinPoints;
         Population[cc1*2+cc2][1]=cc2;
      }
   }
}

void clear() {
  string name;
  int obj_total = ObjectsTotal();
  for (int i=obj_total-1; i>=0; i--)
  {
    name = ObjectName(i);
    if (StringFind(name, prefix) == 0) ObjectDelete(name);
  }
}
double Optimizer(int stepopt, int flag) {
   int barc2, barc3;
   for (int barc1=BarsToCheck;barc1>0;barc1=barc1-stepopt-spread) {
      if (barc1==BarsToCheck) {
         Profit=0;
         ArrayInitialize(BuyS, 0.0);
         ArrayInitialize(SellS, 0.0);
      }
      barc3=barc1;
      if (barc1<stepopt) barc3=1;
      if (debug) Print("bar 1 counter 1 = ",barc1);
      if (barc1<BarsToCheck && flag==1) {
         Profit+=(iClose(Symbol(),0,barc1+stepopt+spread)-iClose(Symbol(),0,barc3))/Point;
         if (debug) Print("Profit = ",Profit);
         flag=0;
         SellS[barc2]=barc1+stepopt+spread;
         if (debug) Print("Sell bar : ",SellS[barc2]," counter : ",barc2);
         barc2++;
         continue;
      }
      if (barc1<BarsToCheck && flag==0) {
         Profit+=(iClose(Symbol(),0,barc3)-iClose(Symbol(),0,barc1+stepopt+spread))/Point;
         if (debug) Print("Profit = ",Profit);
         flag=1;
         BuyS[barc2]=barc1+stepopt+spread;
         if (debug) Print("Buy bar : ",BuyS[barc2]," counter : ",barc2);
         barc2++;
         continue;
      }
   }
}
void Finder() {
   for (int optc=0;optc<Total;optc++) {
      stepopt1=Population[optc][0];
      flag1=Population[optc][1];
      Optimizer(stepopt1, flag1);
      if (Profit>MaxProfit) {
         MaxProfit=Profit;
         beststep=stepopt1;
         bestflag=flag1;
      }
   }
   Optimizer(beststep, bestflag);
//   if (debug) Print("bar counter 1 = ",barc1);
   if (debug) Print("Profit = ",Profit);
   opt=1;
}
void Draw() {
   for (int drawc1=0;drawc1<MaxCount;drawc1++) {
      if (BuyS[drawc1]>0) {
         if (ObjectFind(prefix+BuyS[drawc1]+"buy")==-1) ObjectCreate(prefix+BuyS[drawc1]+"buy",OBJ_ARROW,0,Time[BuyS[drawc1]],Open[BuyS[drawc1]]);
         ObjectSet(prefix+BuyS[drawc1]+"buy",OBJPROP_ARROWCODE,241);
         ObjectSet(prefix+BuyS[drawc1]+"buy",OBJPROP_COLOR,Red);
      }
      if (SellS[drawc1]>0) {
         if (ObjectFind(prefix+SellS[drawc1]+"sell")==-1) ObjectCreate(prefix+SellS[drawc1]+"sell",OBJ_ARROW,0,Time[SellS[drawc1]],Open[SellS[drawc1]]);
         ObjectSet(prefix+SellS[drawc1]+"sell",OBJPROP_ARROWCODE,242);
         ObjectSet(prefix+SellS[drawc1]+"sell",OBJPROP_COLOR,Red);
      }
   }
}

int start() {
   if (opt==0) Finder();
   Draw();
   Comment("Profit : ",Profit,". Total combinations : ",Total);
return(0);
}